Subject: Re: [PATCH] loopback: better handling of packet drops

From: Eric Dumazet <[email-masked]>
Date: Fri, 17 Apr 2009 14:22:30 +0200

David Miller a écrit :
> From: Eric Dumazet <[email-masked]>
> Date: Fri, 17 Apr 2009 12:33:33 +0200
> 
>> Splitting netif_rx() with a helper function boosts tbench
>> performance by 1%, because we can avoid two tests (about netpoll and
>> timestamping)
> 
> Loopback is not a special device no matter how much you wish
> it might be :-)
> 
> This is why I haven't really pursued any further those patches I
> showed you that treat local TCP connections specially, it just had the
> realy possibility to break clever things people might be doing over
> loopback using the packet scheduler classifier and packet scheduler
> actions.

Point taken.

> 
> I also think it is valid to use netpoll over loopback, especially for
> testing.

Oh I didnt knew it was possible/useful, sorry about that.

> 
> So please undo this part of the patch.  You always try to combine
> multiple distinct changes, and I would have taken just your TX drop
> change if you hadn't added this __netif_rx() stuff to it :-(

I followed on this patch to show what I had in mind, and why
I thought it was a transmit error more than a receive one.

1) Do you reject idea of splitting netif_rx() to be able to
   not freeing skb in case of congestion ?
2) If not, do you want me to send two separate patches ?
3) Should I update rx_errors or tx_errors or both ?

Thank you